明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2275|回复: 2

[求助]请问如何生成hatch的边界

[复制链接]
发表于 2007-4-20 20:37:00 | 显示全部楼层 |阅读模式

图上有一个没有边界的hatch...我想为他生成边界

用appendloop函数行吗?  pHat->appendloop(1,objIds) 我用这样的语句时候..net报错

请教一下,该怎么为一个没有边界的hatch生成边界..

谢谢

发表于 2007-4-26 08:07:00 | 显示全部楼层
  1. ;;; HATCHB.LSP ver 2.0
  2. ;;; Recreates hatch boundary by selecting a hatch
  3. ;;; Boundary is created in current layer/color/linetype in WCS
  4. ;;; By Jimmy Bergmark
  5. ;;; Copyright (C) 1997-2003 JTB World, All Rights Reserved
  6. ;;; Website: [url]www.jtbworld.com[/url]
  7. ;;; E-mail: [email]info@jtbworld.com[/email]
  8. ;;; 2000-02-12 - First release
  9. ;;; 2000-03-27 - Counterclockwise arc's and ellipse's fixed
  10. ;;;              Objects created joined to lwpolyline if possible
  11. ;;;              Error-handling, undo of command
  12. ;;;              Can handle PLINETYPE = 0,1,2
  13. ;;; 2000-03-30 - Integrating hatchb and hatchb14
  14. ;;;              Selection of many hatches
  15. ;;;              Splines supported if closed.
  16. ;;; 2001-04-02 - Fixed bug with entmake of line with no Z for r14
  17. ;;; 2001-07-31 - Removed an irritating semicolon to enable polylines to be created.
  18. ;;; 2001-10-04 - Changed mail and homepage so it's easy to find when new versions comes up.
  19. ;;; 2003-02-06 - Minor fix
  20. ;;; 2003-02-17 - Area returned if no islands is found since it's not consistant
  21. ;;; 2003-05-19 - Fix to take PEDITACCEPT variable used in AutoCAD 2004 into account
  22. ;;; Tested on AutoCAD r14, 2000, 2000i, 2002, 2004
  23. ;;; should be working on older versions too.
  24. (defun c:rebuild_hatch_border () (c:hb)) ; this line can be commented out if there is an existing command called hb
  25. (defun c:hb (/     es    blay  ed1   ed2   loops1      bptf  part
  26.              et    noe   plist ic    bul   nr    ang1  ang2  obj *ModelSpace* *PaperSpace*
  27.              space cw errexit undox olderr oldcmdecho ss1 lastent en1 en2 ss lwp
  28.              list->variantArray 3dPoint->2dPoint A2k ent i ss2
  29.              knot-list controlpoint-list kn cn pos xv bot area hst
  30.             )
  31. (setq A2k (>= (substr (getvar "ACADVER") 1 2) "15"))
  32. (if A2k
  33.    (progn
  34.      (defun list->variantArray (ptsList / arraySpace sArray)
  35.        (setq arraySpace
  36.           (vlax-make-safearray
  37.         vlax-vbdouble
  38.         (cons 0 (- (length ptsList) 1))
  39.           )
  40.        )
  41.        (setq sArray (vlax-safearray-fill arraySpace ptsList))
  42.        (vlax-make-variant sArray)
  43.      )
  44.      (defun areaOfObject (en / curve area)
  45.        (if en
  46.      (if A2k
  47.        (progn
  48.          (setq curve (vlax-ename->vla-object en))
  49.          (if
  50.            (vl-catch-all-error-p
  51.          (setq
  52.            area
  53.             (vl-catch-all-apply 'vlax-curve-getArea (list curve))
  54.          )
  55.            )
  56.         nil
  57.         area
  58.          )
  59.        )
  60.        (progn
  61.          (command "._area" "_O" en)
  62.          (getvar "area")
  63.        )
  64.      )
  65.        )
  66.      )
  67.    )
  68. )
  69. (if A2k
  70.   (defun 3dPoint->2dPoint (3dpt)
  71.     (list (float (car 3dpt)) (float (cadr 3dpt)))
  72.   )
  73. )
  74.   (defun errexit (s)
  75.     (princ "\nError:  ")
  76.     (princ s)
  77.     (restore)
  78.   )
  79.   (defun undox ()
  80.     (command "._ucs" "_p")
  81.     (command "._undo" "_E")
  82.     (setvar "cmdecho" oldcmdecho)
  83.     (setq *error* olderr)
  84.     (princ)
  85.   )
  86.   (setq olderr  *error*
  87.         restore undox
  88.         *error* errexit
  89.   )
  90.   (setq oldcmdecho (getvar "cmdecho"))
  91.   (setvar "cmdecho" 0)
  92.   (command "._UNDO" "_BE")
  93.   (if A2k (progn
  94.     (vl-load-com)
  95.     (setq *ModelSpace* (vla-get-ModelSpace
  96.                          (vla-get-ActiveDocument (vlax-get-acad-object))
  97.                        )
  98.           *PaperSpace* (vla-get-PaperSpace
  99.                          (vla-get-ActiveDocument (vlax-get-acad-object))
  100.                        )
  101.     ))
  102.   )
  103. ; For testing purpose
  104. ; (setq A2k nil)
  105.    
  106.   (if (/= (setq ss2 (ssget '((0 . "HATCH")))) nil)
  107.    (progn
  108.     (setq i 0)
  109.     (setq area 0)
  110.     (setq bMoreLoops nil)
  111.     (while (setq ent (ssname ss2 i))
  112.       (setq ed1 (entget ent))
  113.       (if (not (equal (assoc 210 ed1) '(210 0.0 0.0 1.0))) (princ "\nHatch not in WCS!"))
  114.       (setq xv (cdr (assoc 210 ed1)))
  115.       (command "._ucs" "_w")
  116.       (setq loops1 (cdr (assoc 91 ed1))) ; number of boundary paths (loops)
  117.       (if (and A2k (= (strcase (cdr (assoc 410 ed1))) "MODEL"))
  118.         (setq space *ModelSpace*)
  119.         (setq space *PaperSpace*)
  120.       )
  121.       (repeat loops1
  122.         (setq ed1 (member (assoc 92 ed1) ed1))
  123.         (setq bptf (cdr (car ed1))) ; boundary path type flag
  124.         (setq ic (cdr (assoc 73 ed1))) ; is closed
  125.         (setq noe (cdr (assoc 93 ed1))) ; number of edges
  126.     (setq bot (cdr (assoc 92 ed1))) ; boundary type
  127.     (setq hst (cdr (assoc 75 ed1))) ; hatch style
  128.         (setq ed1 (member (assoc 72 ed1) ed1))
  129.         (setq bul (cdr (car ed1))) ; bulge
  130.         (setq plist nil)
  131.         (setq blist nil)
  132.         (cond
  133.           ((> (boole 1 bptf 2) 0) ; polyline
  134.            (repeat noe
  135.              (setq ed1 (member (assoc 10 (cdr ed1)) ed1))
  136.              (setq plist (append plist (list (cdr (assoc 10 ed1)))))
  137.              (setq blist (append blist
  138.                                  (if (> bul 0)
  139.                                    (list (cdr (assoc 42 ed1)))
  140.                                    nil
  141.                                  )
  142.                          )
  143.              )
  144.            )
  145.            (if A2k (progn
  146.              (setq polypoints
  147.                     (apply 'append
  148.                            (mapcar '3dPoint->2dPoint plist)
  149.                     )
  150.              )
  151.              (setq VLADataPts (list->variantArray polypoints))
  152.              (setq obj (vla-addLightweightPolyline space VLADataPts))
  153.              (setq nr 0)
  154.              (repeat (length blist)
  155.                (if (/= (nth nr blist) 0)
  156.                  (vla-setBulge obj nr (nth nr blist))
  157.                )
  158.                (setq nr (1+ nr))
  159.              )
  160.              (if (= ic 1)
  161.                (vla-put-closed obj T)
  162.              )
  163.             )
  164.             (progn
  165.               (if (= ic 1)
  166.                 (entmake '((0 . "POLYLINE") (66 . 1) (70 . 1)))
  167.                 (entmake '((0 . "POLYLINE") (66 . 1)))
  168.               )
  169.               (setq nr 0)
  170.               (repeat (length plist)
  171.                 (if (= bul 0)
  172.                   (entmake (list (cons 0 "VERTEX")
  173.                                  (cons 10 (nth nr plist))
  174.                            )
  175.                   )
  176.                   (entmake (list (cons 0 "VERTEX")
  177.                                  (cons 10 (nth nr plist))
  178.                                  (cons 42 (nth nr blist))
  179.                            )
  180.                   )
  181.                 )
  182.                 (setq nr (1+ nr))
  183.               )
  184.               (entmake '((0 . "SEQEND")))
  185.             )
  186.            )
  187.           )
  188.           (t ; not polyline
  189.            (setq lastent (entlast))
  190.            (setq lwp T)
  191.            (repeat noe
  192.              (setq et (cdr (assoc 72 ed1)))
  193.              (cond
  194.                ((= et 1) ; line
  195.                 (setq ed1 (member (assoc 10 (cdr ed1)) ed1))
  196.                 (if A2k
  197.                   (vla-AddLine
  198.                     space
  199.                     (vlax-3d-point (cdr (assoc 10 ed1)))
  200.                     (vlax-3d-point (cdr (assoc 11 ed1)))
  201.                   )
  202.                   (entmake
  203.                     (list
  204.                       (cons 0 "LINE")
  205.                       (list 10 (cadr (assoc 10 ed1)) (caddr (assoc 10 ed1)) 0)
  206.                       (list 11 (cadr (assoc 11 ed1)) (caddr (assoc 11 ed1)) 0)
  207.             ;  (cons 210 xv)
  208.                     )
  209.                   )
  210.                 )
  211.                 (setq ed1 (cddr ed1))
  212.                )
  213.                ((= et 2) ; circular arc
  214.                  (setq ed1 (member (assoc 10 (cdr ed1)) ed1))
  215.                  (setq ang1 (cdr (assoc 50 ed1)))
  216.                  (setq ang2 (cdr (assoc 51 ed1)))
  217.                  (setq cw (cdr (assoc 73 ed1)))
  218.                  (if (equal ang2 6.28319 0.00001)
  219.                    (progn
  220.                      (if A2k
  221.                        (vla-AddCircle
  222.                          space
  223.                          (vlax-3d-point (cdr (assoc 10 ed1)))
  224.                          (cdr (assoc 40 ed1))
  225.                        )
  226.                        (entmake (list (cons 0 "CIRCLE")
  227.                                       (assoc 10 ed1)
  228.                                       (assoc 40 ed1)
  229.                                 )
  230.                        )
  231.                      )
  232.                      (setq lwp nil)
  233.                    )
  234.                    (if A2k
  235.                      (vla-AddArc
  236.                        space
  237.                        (vlax-3d-point (cdr (assoc 10 ed1)))
  238.                        (cdr (assoc 40 ed1))
  239.                        (if (= cw 0)
  240.                          (- 0 ang2)
  241.                          ang1
  242.                        )
  243.                        (if (= cw 0)
  244.                          (- 0 ang1)
  245.                          ang2
  246.                        )
  247.                      )
  248.                      (entmake (list (cons 0 "ARC")
  249.                                     (assoc 10 ed1)
  250.                                     (assoc 40 ed1)
  251.                                     (cons 50
  252.                                           (if (= cw 0)
  253.                                             (- 0 ang2)
  254.                                             ang1
  255.                                           )
  256.                                     )
  257.                                     (cons 51
  258.                                           (if (= cw 0)
  259.                                             (- 0 ang1)
  260.                                             ang2
  261.                                           )
  262.                                     )
  263.                               )
  264.                      )
  265.                    )
  266.                  )
  267.                  (setq ed1 (cddddr ed1))
  268.                )
  269.                ((= et 3) ; elliptic arc
  270.                 (setq ed1 (member (assoc 10 (cdr ed1)) ed1))
  271.                 (setq ang1 (cdr (assoc 50 ed1)))
  272.                 (setq ang2 (cdr (assoc 51 ed1)))
  273.                 (setq cw (cdr (assoc 73 ed1)))
  274.                 (if A2k (progn
  275.                   (setq obj (vla-AddEllipse
  276.                               space
  277.                               (vlax-3d-point (cdr (assoc 10 ed1)))
  278.                               (vlax-3d-point (cdr (assoc 11 ed1)))
  279.                               (cdr (assoc 40 ed1))
  280.                             )
  281.                   )
  282.                   (vla-put-startangle obj (if (= cw 0) (- 0 ang2) ang1))
  283.                   (vla-put-endangle obj (if (= cw 0) (- 0 ang1) ang2))
  284.                  )
  285.                  (princ "\nElliptic arc not supported!")
  286.                 )
  287.                 (setq lwp nil)
  288.                )
  289.                ((= et 4) ; spline
  290.                 (setq ed1 (member (assoc 94 (cdr ed1)) ed1))
  291.                 (setq knot-list nil)
  292.                 (setq controlpoint-list nil)
  293.         (setq kn (cdr (assoc 95 ed1)))
  294.                 (setq cn (cdr (assoc 96 ed1)))
  295.                 (setq pos (vl-position (assoc 40 ed1) ed1))
  296.                 (repeat kn
  297.                   (setq knot-list (cons (cons 40 (cdr (nth pos ed1))) knot-list))
  298.                   (setq pos (1+ pos))
  299.                 )
  300.                 (setq pos (vl-position (assoc 10 ed1) ed1))
  301.                 (repeat cn
  302.                   (setq controlpoint-list (cons (cons 10 (cdr (nth pos ed1))) controlpoint-list))
  303.                   (setq pos (1+ pos))
  304.                 )
  305.                 (setq knot-list (reverse knot-list))
  306.                 (setq controlpoint-list (reverse controlpoint-list))
  307.                 (entmake (append
  308.                        (list '(0 . "SPLINE"))
  309.                                (list (cons 100 "AcDbEntity"))
  310.                                (list (cons 100 "AcDbSpline"))
  311.                                (list (cons 70 (+ 1 8 (* 2 (cdr (assoc 74 ed1))) (* 4 (cdr (assoc 73 ed1))))))
  312.                                (list (cons 71 (cdr (assoc 94 ed1))))
  313.                                (list (cons 72 kn))
  314.                                (list (cons 73 cn))
  315.                                knot-list
  316.                                controlpoint-list
  317.                       )
  318.                 )
  319.         (setq ed1 (member (assoc 10 ed1) ed1))
  320.                 (setq lwp nil)
  321.                )
  322.              ) ; end cond
  323.            ) ; end repeat noe
  324.            (if lwp (progn
  325.              (setq en1 (entnext lastent))
  326.              (setq ss (ssadd))
  327.              (ssadd en1 ss)
  328.              (while (setq en2 (entnext en1))
  329.                (ssadd en2 ss)
  330.                (setq en1 en2)
  331.              )
  332.          (if (= (getvar "peditaccept") 1)
  333.                (command "_.pedit" (entlast) "_J" ss "" "")
  334.            (command "_.pedit" (entlast) "_Y" "_J" ss "" "")
  335.          )
  336.           ))
  337.           ) ; end t
  338.         ) ; end cond
  339. ;    Tries to get the area on islands but it's not clear how to know if an island is filled or not
  340. ;    and if it should be substracted or added to the total area.
  341. ;    (if (or (= bot 0) (= (boole 1 bot 1) 1)) (setq area (+ area (areaOfObject (entlast)))))
  342. ;    (if (and (/= hst 1) (/= bot 0) (= (boole 1 bot 1) 0)) (setq area (- area (areaOfObject (entlast)))))
  343. ;    (princ "\n") (princ bot) (princ "\n") (princ hst) (princ "\n")
  344. ;    (princ (areaOfObject (entlast)))
  345.       ) ; end repeat loops1
  346.       (if (= loops1 1) (setq area (+ area (areaOfObject (entlast)))) (setq bMoreLoops T))
  347.       (setq i (1+ i))
  348.     )
  349.    )
  350.   )
  351.   (if (and area (not bMoreLoops)) (progn
  352.     (princ "\nTotal Area = ")
  353.     (princ area)
  354.   ))
  355.   (restore)
  356.   (princ)
  357. )
输入HB即可!

点评

谢谢了,就要这个好东西  发表于 2012-3-13 15:34
发表于 2012-10-30 14:10:49 | 显示全部楼层
看着好复杂啊。
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 10:26 , Processed in 0.172070 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表